module Legion
  module Extensions
    module Transport
      module AutoBuild
        def build
          build_e_to_e
          build_e_to_q
        end

        def require_exchanges; end

        def require_queues; end

        def build_e_to_q
          e_to_q.each do |binding|
            options = {}
            options[:routing_key] = binding[:routing_key] unless binding[:routing_key].nil?
            bind(binding[:from], binding[:to], options)
          end
        end

        def build_e_to_e
          e_to_e.each do |binding|
            options = {}
            options[:routing_key] = binding[:routing_key] unless binding[:routing_key].nil?
            bind(binding[:from], binding[:to], options)
          end
        end

        def bind(from, to, options = {})
          from = from.new
          to = to.new
          to.bind(from, routing_key: options[:routing_key]) unless options[:routing_key].nil?
          to.bind(from) if options[:routing_key].nil?
        end

        def e_to_q
          []
        end

        def e_to_e
          []
        end
      end
    end
  end
end
